<?php

class PayanywayValidationModuleFrontController extends ModuleFrontController
{
	/**
	 * @see FrontController::postProcess()
	 */
	public function postProcess()
	{
		$cart = $this->context->cart;
		if ($cart->id_customer == 0 || !$this->module->active)
			Tools::redirect('index.php?controller=order&step=1');

		// Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
		$authorized = false;
		foreach (Module::getPaymentModules() as $module)
			if ($module['name'] == 'payanyway')
			{
				$authorized = true;
				break;
			}
		if (!$authorized)
			die('This payment method is not available.');

		$customer = new Customer($cart->id_customer);
		if (!Validate::isLoadedObject($customer))
			Tools::redirect('index.php?controller=order&step=1');

		$total = (float)$cart->getOrderTotal(true, Cart::BOTH);
		$cart = $this->context->cart;
		$currency = new Currency((int)($cart->id_currency));
		$amount = number_format($cart->getOrderTotal(true, 3), 2, '.', '');
		$mnt_signature = md5(Configuration::get('PAYANYWAY_MNT_ID').(int)$cart->id.$amount.$currency->iso_code.
			Configuration::get('PAYANYWAY_MNT_TEST_MODE').Configuration::get('PAYANYWAY_MNT_DATAINTEGRITY_CODE'));
		$params= [
			'MNT_ID' => Configuration::get('PAYANYWAY_MNT_ID'),
			'MNT_TRANSACTION_ID' => (int)$cart->id,
			'MNT_TEST_MODE' => Configuration::get('PAYANYWAY_MNT_TEST_MODE'),
			'MNT_CURRENCY_CODE' => $currency->iso_code,
			'MNT_AMOUNT' => $amount,
			'MNT_SIGNATURE' => $mnt_signature,
			'MNT_SUCCESS_URL' => Tools::getShopDomain(true, true).__PS_BASE_URI__.
					'index.php?controller=order-confirmation&id_cart='.($cart->id).'&id_module='.($this->module->id).
					'&key='.$customer->secure_key.'&status=success',
			'MNT_FAIL_URL' => Tools::getShopDomain(true, true).__PS_BASE_URI__.
					'index.php?controller=order-confirmation&id_cart='.($cart->id).'&id_module='.($this->module->id).
					'&key='.$customer->secure_key.'&status=fail',
		];
		$urlParams = [];
		foreach ($params as $key => $value)
			$urlParams[] = $key."=".urlencode($value);

		$this->module->validateOrder($cart->id, Configuration::get('PAYANYWAY_OS_WAITING'), $total,
			$this->module->displayName, NULL, array(), (int)$currency->id, false, $customer->secure_key);
		$url = "https://".Configuration::get('PAYANYWAY_PAYMENT_URL')."/assistant.htm?";
		Tools::redirect($url. implode("&", $urlParams), '');
	}
}
